use std::collections::HashSet;
use std::error;
use std::fs::File;
use std::io::BufRead;
use std::io::BufReader;


fn set_from_str(chars: &str) -> HashSet<u32> {
	HashSet::from_iter(chars.chars().map(|c| if c.is_uppercase() { c as u32 - 38 } else { c as u32 - 96 }))
}


fn main() -> Result<(), Box<dyn error::Error>> {
	let f = File::open("input.txt")?;
	let reader = BufReader::new(f);

	let mut sum: u32 = 0;
	let mut group_items: HashSet<u32> = HashSet::new();

	for (i, line) in reader.lines().enumerate() {
		let line = line?;
		if group_items.is_empty() {
			group_items = set_from_str(line.as_str());
		} else {
			group_items = set_from_str(line.as_str()).intersection(&group_items).cloned().collect();
		}
		if (i + 1) % 3 == 0 {
			sum += group_items.iter().next().unwrap();
			group_items.drain();
		}
	}

	println!("{}", sum);

    Ok(())
}
